---
- name: Install CILOGON into Kratos
  hosts: localhost   # whatever command and control node you use.

  tasks:
    - name: Download tools (yq)
      ansible.builtin.unarchive:
        src: https://github.com/mikefarah/yq/releases/download/v4.44.1/yq_linux_amd64.tar.gz
        dest: /tmp
        remote_src: yes

    - name: Install tools (yq)
      become: yes
      ansible.builtin.copy: 
        src: /tmp/yq_linux_amd64
        dest: /usr/local/bin/yq
        mode: '755'
        owner: root
    

    - name: Fetch existing auth helm values
      ansible.builtin.command:
        argv:
          - helm
          - get
          - values
          - -n 
          - "{{ ns }}" 
          - "{{ auth.appname }}"
          - -o
          - yaml
      register: helm_values_out

    - name: Create temp file to merge
      ansible.builtin.tempfile:
        state: file
      register: auth_values_file

    - name: Write existing values to tmp file
      ansible.builtin.copy:
        content: "{{ helm_values_out.stdout }}"
        dest: "{{ auth_values_file.path }}"

    - name: Merge CILOGON config into values
      ansible.builtin.command:
        argv:
          - yq
          - eval-all
          - '. as $item ireduce ({}; . *+ $item )'
          - "{{ auth_values_file.path }}"
          - files/cilogin-kratos-cm.yml
      register: merged_values

    - name: Create temp file for merged values
      ansible.builtin.tempfile:
        state: file
      register: merged_values_file

    - name: Create merged values file
      ansible.builtin.copy:
        content: "{{ merged_values.stdout }}"
        dest: "{{ merged_values_file.path }}"

    - name: Dump merged values
      debug:
        msg: "{{ merged_values.stdout }}"

    - name: Update Auth Install with CILOGON values
      kubernetes.core.helm:
        name: "{{ auth.appname }}"
        chart_ref: "{{ auth.chartref }}"
        release_namespace: "{{ ns }}"
        values_files:
          - "{{ merged_values_file.path }}"

    - name: Remove tmp orginal values file
      ansible.builtin.file:
        state: absent
        path: "{{ auth_values_file.path }}"
      when: auth_values_file.path is defined

    - name: Remove tmp merged values file
      ansible.builtin.file:
        state: absent
        path: "{{ merged_values_file.path }}"
      when: merged_values_file.path is defined
